
Redmine - Defect #13617

Internal error on custum queries after Upgrade 2.2 -> 2.3

2013-03-28 00:05 - F Schroedter

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: Database Estimated time: 0.00 hour

Target version:    

Resolution: Invalid Affected version: 2.3.0

Description

After upgrading redmine from 2.2 to 2.3 I get a internal error on custom queries. I created the same query on 2.3 and compared the

database column "filter" from table "queries":

 --- 

 status_id: 

   :operator: o

   :values: 

-  - ''

+  - "" 

 author_id: 

-  :operator: =

+  :operator: "=" 

   :values: 

   - me

 Adapting the filter on the database manually solved the problem.

And yes, I did run "rake db:migrate RAILS_ENV=production" after upgrading.

Related issues:

Related to Redmine - Defect #19305: settings: incompatible character encoding... Closed

Blocked by Redmine - Defect #13667: Internal error on custum queries after Up... Closed

History

#1 - 2013-03-28 00:21 - F Schroedter

The only problem for all custom issue queries was, that it had to be

 :operator: "="

instead of

 :operator: =

#2 - 2013-03-28 14:55 - Etienne Massip

- Target version set to 2.3.1

Not confirmed yet but I remember a commit going this way in Query refactoring so it's worth digging into this for next minor release.

#3 - 2013-04-03 18:54 - Jean-Philippe Lang

I don't think it's related to the Query refactoring. Looks like an incompatibility in YAML parsing between ruby versions.

Did you upgrade your ruby while upgrading to 2.3? And could you post your stack trace and your ruby version(s) (see SubmittingBugs)?

#4 - 2013-04-03 19:10 - F Schroedter

I used Redmine 2.2 also with Ruby 1.9.2

My configuration with Redmine 2.3 now:
Ruby version              1.9.2 (x86_64-linux)

RubyGems version          1.8.24

Rack version              1.4

Rails version             3.2.13

Active Record version     3.2.13

Action Pack version       3.2.13

Active Resource version   3.2.13

Action Mailer version     3.2.13

Active Support version    3.2.13

#5 - 2013-04-03 19:40 - Etienne Massip

Jean-Philippe Lang wrote:

I don't think it's related to the Query refactoring. Looks like an incompatibility in YAML parsing between ruby versions.

 The commit I was thinking about was indeed more something like using "" instead of "=" as equality operator.

#6 - 2013-04-03 20:21 - F Schroedter

What of these is the problem/unexpected behaviour?

1. Redmine 2.2 stores :operator: = instead of :operator: "=" in the database

2. In Redmine 2.3 occures an "internal error" when applying the filter with :operator: =

BTW, my Redmine 2.2 uses the rails version 3.2.11. Ruby and RubyGems version is the same.

I have Redmine 2.2 still on my server, so I can provide you with informations if needed.

#7 - 2013-04-03 20:46 - Etienne Massip

Could you try 2.3 with RoR 3.2.11? There has been some security fixes related to json and xml parsing in latest releases.

#8 - 2013-04-03 21:34 - F Schroedter

I tried redmine 2.3 with rails 3.2.11. No difference to 3.2.13.

#9 - 2013-04-03 21:41 - F Schroedter

My stack trace in Redmine 2.3 with a "bad" filter:

Started GET "/projects/myproject/issues?query_id=9" for 95.113.249.160 at 2013-04-03 20:56:24 +0200

Processing by IssuesController#index as HTML

  Parameters: {"query_id"=>"9", "project_id"=>"myproject"}

  Current user: fschroedter (id=3)

Completed 500 Internal Server Error in 117ms

RuntimeError (Unknown query operator #<Syck::DefaultKey:0x0000000c076348>):

  app/models/query.rb:724:in `sql_for_field'

  app/models/query.rb:544:in `block in statement'

  app/models/query.rb:512:in `each_key'

  app/models/query.rb:512:in `statement'

  app/models/issue_query.rb:230:in `issue_count'

  app/controllers/issues_controller.rb:73:in `index'

#10 - 2013-04-07 13:11 - Filou Centrinov

I tested with Redmine 2.3 where 

:operator: =

is stored. It works when requesting the filter.

Ruby version              1.9.3 (i386-mingw32)

RubyGems version          2.0.2

Rack version              1.4

Rails version             3.2.13

#11 - 2013-04-13 13:20 - Filou Centrinov
Category: Database

#12 - 2013-04-13 13:30 - Toshi MARUYAMA

- Category changed from Issues to Database

#13 - 2013-05-01 15:19 - Jean-Philippe Lang

- Target version changed from 2.3.1 to Candidate for next major release

Redmine is not responsible for storing these serialized values, Rails and YAML.dump are. So I don't have any ideas on how to fix this in Redmine. I

personnaly did not experience this problem after upgrading to 2.3.

#14 - 2013-12-04 22:34 - Scott H

I started using Redmine 2.3.3 a month ago, updated to 2.4.0 the other day, and noticed the same thing. My Ruby version actually went down though,

moving from a Windows machine with 1.9.3 to Linux with 1.8.7.

Also worth noting that not every custom query will get the error, you need to have certain parameters saved for it to matter.

#15 - 2014-03-03 11:50 - Jan from Planio www.plan.io

- File 20140303094355_fix_query_yaml.rb added

For various reasons, we're still using Syck at Planio despite running on Ruby 2.0 already. This bug however seems to occur even with the syck gem

while it didn't with syck in Ruby < 1.9. The attached migration doesn't hurt and fixes the problem at hand while a more thorough solution would be to

load old yaml using syck and re-generate it using psych...

#16 - 2015-03-08 17:17 - Toshi MARUYAMA

- Related to Defect #19305: settings: incompatible character encodings: UTF-8 and ASCII-8BIT: yaml generated on ruby 1.8 added

#17 - 2015-03-08 17:24 - Toshi MARUYAMA

OpenProject (GPL3) provides yaml converter.

https://github.com/opf/openproject/blob/v4.0.8/db/migrate/migration_utils/yaml_migrator.rb

#18 - 2019-01-10 03:32 - Marius BĂLTEANU

- Status changed from New to Resolved

- Target version deleted (Candidate for next major release)

I don't think that is something that we can do here for the next Redmine versions. If someone still has this problem, it can find in the comments how to

fix it (the query posted by Jan can be run manually).

#19 - 2019-01-10 03:53 - Marius BĂLTEANU

- Status changed from Resolved to Closed

- Resolution set to Invalid

Files

20140303094355_fix_query_yaml.rb 196 Bytes 2014-03-03 Jan from Planio www.plan.io
